# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rsm_msgs/OperationMode.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class OperationMode(genpy.Message):
  _md5sum = "3a2b892239d01889665a0278d874ed60"
  _type = "rsm_msgs/OperationMode"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """#Operation mode including information about emergency stop
bool emergencyStop					# Is emergency stop activated

uint8 STOPPED = 0        			# Robot is stopped
uint8 AUTONOMOUS = 1     				# Robot is controlled by the autonomy cmd vel topic	
uint8 TELEOPERATION = 2        		# Robot is controlled by the teleoperation cmd vel topic	

uint8 mode							# Operation mode
"""
  # Pseudo-constants
  STOPPED = 0
  AUTONOMOUS = 1
  TELEOPERATION = 2

  __slots__ = ['emergencyStop','mode']
  _slot_types = ['bool','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       emergencyStop,mode

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(OperationMode, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.emergencyStop is None:
        self.emergencyStop = False
      if self.mode is None:
        self.mode = 0
    else:
      self.emergencyStop = False
      self.mode = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.emergencyStop, _x.mode))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 2
      (_x.emergencyStop, _x.mode,) = _get_struct_2B().unpack(str[start:end])
      self.emergencyStop = bool(self.emergencyStop)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2B().pack(_x.emergencyStop, _x.mode))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      _x = self
      start = end
      end += 2
      (_x.emergencyStop, _x.mode,) = _get_struct_2B().unpack(str[start:end])
      self.emergencyStop = bool(self.emergencyStop)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
